com.holonplatform.vaadin.components.builders

## Interface CalendarInputBuilder<T,B extends CalendarInputBuilder<T,B>>

- Type Parameters:
    `T` - Value type
    `B` - Concrete builder type
  All Superinterfaces:
    ComponentConfigurator<B>, InputBuilder<T,Input<T>,B>, InputConfigurator<T,B>
  All Known Subinterfaces:
    DateInputBuilder, TemporalInputBuilder<T,B>, TemporalInputBuilder.TemporalWithoutTimeFieldBuilder<T>, TemporalInputBuilder.TemporalWithTimeFieldBuilder<T>

      public interface CalendarInputBuilder<T,B extends CalendarInputBuilder<T,B>>
      extends InputBuilder<T,Input<T>,B>

  An builder to create `Input`s rendered as a calendar (inline or in a popup activated by a button) in UI.
  Since:
    5.0.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.InputConfigurator

      `InputConfigurator.BaseFieldConfigurator<T>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `ComponentConfigurator.BaseComponentConfigurator`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `B` | `dateFormat(String dateFormat)` Sets date format to use for internal component date display.
    `B` | `dateOutOfRangeMessage(com.holonplatform.core.i18n.Localizable dateOutOfRangeMessage)` Sets the error message to notify if the range validation fails, using a `Localizable` message.
    `B` | `dateOutOfRangeMessage(String dateOutOfRangeMessage)` Sets the error message to notify if the range validation fails.
    `B` | `dateOutOfRangeMessage(String defaultDateOutOfRangeMessage, String messageCode, Object... arguments)` Sets the error message to notify if the range validation fails, using a localizable `messageCode`.
    `B` | `lenient(boolean lenient)` Specifies whether or not date/time interpretation in component is to be lenient.
    `B` | `parseErrorMessage(com.holonplatform.core.i18n.Localizable parseErrorMessage)` Sets the default error message used if the DateField cannot parse the text input by user to a Date field, using a `Localizable` message.
    `B` | `parseErrorMessage(String parsingErrorMessage)` Sets the default error message used if the DateField cannot parse the text input by user to a Date field.
    `B` | `parseErrorMessage(String defaultParseErrorMessage, String messageCode, Object... arguments)` Sets the default error message used if the DateField cannot parse the text input by user to a Date field, using a localizable `messageCode`.
    `B` | `rangeEnd(T end)` Sets the end range for this component.
    `B` | `rangeStart(T start)` Sets the start range for this component.
    `B` | `showISOWeekNumbers(boolean showWeekNumbers)` Sets the visibility of ISO 8601 week numbers in the date selector.
    `B` | `timeZone(TimeZone timeZone)` Sets the time zone used by this date field.

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.InputBuilder

      `asField, build, deferLocalization, dragSource, dropTarget, validatable`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.InputConfigurator

      `locale, readOnly, tabIndex, withValue, withValueChangeListener`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `caption, caption, caption, captionAsHtml, description, description, description, disabled, errorHandler, fullHeight, fullSize, fullWidth, height, height, heightUndefined, hidden, icon, id, notVisible, primaryStyleName, replaceStyleName, responsive, sizeUndefined, styleName, width, width, widthUndefined, withAttachListener, withContextClickListener, withData, withDetachListener, withShortcutListener`

- - ### Method Detail

    - #### dateFormat

          B dateFormat(String dateFormat)

      Sets date format to use for internal component date display.
      Parameters:
        `dateFormat` - the dateFormat to set
      Returns:
        this

    - #### parseErrorMessage

          B parseErrorMessage(String parsingErrorMessage)

      Sets the default error message used if the DateField cannot parse the text input by user to a Date field.
      Parameters:
        `parsingErrorMessage` - Parse error message
      Returns:
        this

    - #### parseErrorMessage

          B parseErrorMessage(String defaultParseErrorMessage,
                              String messageCode,
                              Object... arguments)

      Sets the default error message used if the DateField cannot parse the text input by user to a Date field, using a localizable `messageCode`.

      For message localization, a `LocalizationContext` must be available and localized as `Context` resource when component is built.

      Parameters:
        `defaultParseErrorMessage` - Default error message if no translation is available for given `messageCode` for current Locale.
        `messageCode` - Parse error message translation message key
        `arguments` - Optional translation arguments
      Returns:
        this

    - #### parseErrorMessage

          B parseErrorMessage(com.holonplatform.core.i18n.Localizable parseErrorMessage)

      Sets the default error message used if the DateField cannot parse the text input by user to a Date field, using a `Localizable` message.

      For message localization, a `LocalizationContext` must be available and localized as `Context` resource when component is built.

      Parameters:
        `parseErrorMessage` - Localizable error message
      Returns:
        this

    - #### lenient

          B lenient(boolean lenient)

      Specifies whether or not date/time interpretation in component is to be lenient.
      Parameters:
        `lenient` - true if the lenient mode is to be turned on; false if it is to be turned off.
      Returns:
        this
      See Also:
        `Calendar.setLenient(boolean)`

    - #### showISOWeekNumbers

          B showISOWeekNumbers(boolean showWeekNumbers)

      Sets the visibility of ISO 8601 week numbers in the date selector. ISO 8601 defines that a week always starts with a Monday so the week numbers are only shown if this is the case.
      Parameters:
        `showWeekNumbers` - true if week numbers should be shown, false otherwise.
      Returns:
        this

    - #### timeZone

          B timeZone(TimeZone timeZone)

      Sets the time zone used by this date field. The time zone is used to convert the absolute time in a Date object to a logical time displayed in the selector and to convert the select time back to a Date object. If no time zone has been set, the current default time zone is used.
      Parameters:
        `timeZone` - the time zone to use for time calculations.
      Returns:
        this

    - #### rangeStart

          B rangeStart(T start)

      Sets the start range for this component. If the value is set before this date/time, the component will not validate. If `start` is set to `null`, any value before end range will be accepted by the range.
      Parameters:
        `start` - the allowed range's start date/time (inclusive)
      Returns:
        this

    - #### rangeEnd

          B rangeEnd(T end)

      Sets the end range for this component. If the value is set after this date/time, the component will not validate. If `end` is set to `null`, any value after start range will be accepted by the range.
      Parameters:
        `end` - the allowed range's end date (inclusive)
      Returns:
        this

    - #### dateOutOfRangeMessage

          B dateOutOfRangeMessage(String dateOutOfRangeMessage)

      Sets the error message to notify if the range validation fails.
      Parameters:
        `dateOutOfRangeMessage` - Localizable message which is shown when value (the date) is set outside allowed range
      Returns:
        this

    - #### dateOutOfRangeMessage

          B dateOutOfRangeMessage(String defaultDateOutOfRangeMessage,
                                  String messageCode,
                                  Object... arguments)

      Sets the error message to notify if the range validation fails, using a localizable `messageCode`.

      For caption localization, a `LocalizationContext` must be available and localized as `Context` resource when component is built.

      Parameters:
        `defaultDateOutOfRangeMessage` - Default error message if no translation is available for given `messageCode` for current Locale.
        `messageCode` - Date out of range message translation message key
        `arguments` - Optional translation arguments
      Returns:
        this

    - #### dateOutOfRangeMessage

          B dateOutOfRangeMessage(com.holonplatform.core.i18n.Localizable dateOutOfRangeMessage)

      Sets the error message to notify if the range validation fails, using a `Localizable` message.

      For caption localization, a `LocalizationContext` must be available and localized as `Context` resource when component is built.

      Parameters:
        `dateOutOfRangeMessage` - Localizable error message
      Returns:
        this

Copyright © 2019 The Holon Platform. All rights reserved.